c   *** explanation of variables ***
c
c    ig = num. of generic variables
c    isp(mode) = num. of mode specific variables for each mode
c    ise = num. of socio-economic variables
c
c    msc( i ) = 1 ---(use mode specific constant for i mode)
c               0 ---(no - use)
c
c    nv = num. of total var.
c    idt(nv) = input data
c
c    lgn(mode,ig)  = data no of generic var. for each mode
c    lsp(mode,isp) = data no of mode-specific var. for each mode
c    lse(ise)      = data no of socio-economic var.
c
c    nn = ig + iss + ise*(mode-1) + mss
c      where   iss : sum of isp
c              mss : sum of msc
c                      Copyright (c) Japan Society of Traffic Engineers
c
      parameter(n1=4,n2=10,nss=500,nvv=125,nl=5)
      dimension data(n2,n1,nss),g(n1,nss),gs(n1),ave(n2,n1),sd(n2,n1),
     *       p(n1,nss),theta(n2),gj(n2,n2*2),f(n2,n2),ff(n2,n2),fu(n2),
     *       nb(n2,2),x(n2),dx(n2),pp(n1),modeal(n1,nss),e(n1)
      dimension pnum(n1+4,n1),ttj(n1+2),pshr(n1+1),pcor(n1),sind(n1)
      dimension idt(nvv),lgn(n1,nl),lsp(n1,nl),lse(nl),isp(n1),dt(n2,n1)
      dimension adt(nvv)
      real*8 gj,f,ff,fu,x,dx,e
      integer*2 modeal,g
c
      open(5,file='cntl.dat')
      open(10,file='test.dat')
c
      n3=n2+1
      read(5,100) mode
      read(5,100)ig,(isp(i),i=1,mode),ise,msc
      if(ig.eq.0) go to 1
      do 5 i=1,ig
    5 read(5,100) (lgn(j,i),j=1,mode)
    1 continue
      do 10 i=1,mode
      is=isp(i)
      if(is.eq.0) go to 10
      read(5,100)(lsp(i,j),j=1,is)
   10 continue
      if(ise.eq.0) go to 2
      read(5,100)(lse(j),j=1,ise)
  100 format(16i5)
    2 continue
      write(6,600)ig
  600 format(///1h ,2x,'num. of generic var. =',i5)
      if(ig.eq.0) go to 3
      write(6,300)(i,i=1,mode)
  300 format(1h0,5x,'mode',12x,5i5)
      do 30 j=1,ig
   30 write(6,601)j,(lgn(i,j),i=1,mode)
  601 format(1h ,5x,i3,5x,'var. no.',5i5)
    3 continue
      do 31 i=1,mode
      write(6,602)i,isp(i)
  602 format(1h0,2x,'mode<',i1,'>',5x,'num. of mode-specific var. =',i5)
      is=isp(i)
      if(is.eq.0) go to 31
      write(6,606)(lsp(i,j),j=1,is)
   31 continue
      write(6,603)ise
  603 format(//1h0,2x,'num. of socio-economic var. =',i5)
      if(ise.eq.0) go to 4
      write(6,606)(lse(j),j=1,ise)
  606 format(1h ,13x,'var. no.',5i5)
    4 continue
      if(msc.eq.1) write(6,604)
      if(msc.eq.0) write(6,605)
  604 format(//1h0,5x,'mode-specific-constant  used')
  605 format(//1h0,5x,'mode-specific-constant  not used')
c
c
      ns2=0
c
c
 1984 read(10,*,end=84) (idt(j),j=1,8)
c
c    jumping start
c
      mal1=idt(2)
      mal2=idt(3)
      mal3=idt(4)
      mmm=idt(2)+idt(3)+idt(4)
      if(mmm.le.1) go to 1984
c
c    jumping end
c
      do 1991 j=1,8
 1991 adt(j)=float(idt(j))
c
      ns2=ns2+1
c
c    modeal(j,i): j mode availability that of i sample
      do 1990 j=1,mode
 1990 modeal(j,ns2)=idt(j+1)
c
c    g(j,i): whether i sample selests j mode or not
      do 19 j=1,mode
   19 g(j,ns2)=0
c
      g(idt(1),ns2)=1
c
c
      call change(adt,lgn,lsp,lse,msc,ig,isp,ise,mode,nn,n1,n2,dt)
c
      do 22 j=1,mode
      do 22 k=1,nn
      data(k,j,ns2)=dt(k,j)
   22 continue
c
c
   20 go to 1984
c
c
c
   84 ns=ns2
c
      call meansd(data,ns,nn,mode,n1,n2,ave,sd,modeal,gs)
c
      call errchk(n1,n2,nss,mode,nn,ns,modeal,g,gs)
c
c
c     caliculate initial-likelihood (al0)
c
      gsum=float(ns)
      al0=0.0
      do 113 j=1,mode
      gs(j)=0.0
      do 113 i=1,ns
  113 gs(j)=gs(j)+float(g(j,i))
      do 114 i=1,mode
  114 al0=al0+gs(i)*alog(gs(i)/gsum)
      write(6,115) al0
  115 format(/1h ,'  l*(0)=  ',e15.4)
c
       call newtn2(theta,g,gs,data,p,gj,x,dx,f,ff,fu,nb,nn,mode,ns,
     *             n1,n2,n3,al0,modeal,e)
       call maxprb(p,g,ns,mode,n1,pnum,ttj,pshr,pcor,sind)
c
      stop
      end
c
c
c
      subroutine newtn2(theta,g,gs,data,p,gj,x,dx,f,ff,fu,nb,nn,
     /                  mode,ns,n1,n2,n3,al0,modeal,e)
c
      dimension theta(1),g(n1,1),gs(1),data(n2,n1,1),p(n1,1),gj(n2,1)
     /         ,x(1),dx(1),f(n2,1),ff(n2,1),fu(1),nb(n2,1),modeal(n1,1)
      dimension e(1)
c
      real*8  gj,x,dx,f,ff,fu,eps,det,h,e,ee,ww
      integer*2  modeal,g
c
       eps=1.0d-8
c
c      clear  theta
      do 10 i=1,nn
      x(i)=0.0
   10 theta(i)=0.0
c
c      loop  point
c
       it=0
    1 continue
c
c     set function value vector & information matrix
c
      do 11 i=1,nn
      fu(i)=0.0
      do 11 j=1,nn
   11 f(i,j)=0.0
c
      idf=0
c
      do 500 i=1,ns
c
      ee=0.0
c
      do 510 j=1,mode
      idf=idf+modeal(j,i)
      e(j)=0.0
      if(modeal(j,i).eq.1) then
        do 520 k=1,nn
  520   e(j)=e(j)+theta(k)*data(k,j,i)
        e(j)=dexp(e(j))
      end if
      ee=ee+e(j)
  510 continue
c
      do 530 j=1,mode
  530 p(j,i)=e(j)/ee
c
      do 540 j=1,mode
      ee=0.0
      if(g(j,i).eq.1) ee=1.0
      do 550 k=1,nn
      fu(k)=fu(k)+(ee-p(j,i))*data(k,j,i)
        do 560 l=1,nn
        ww=0.0
        do 570 m=1,mode
  570   ww=ww+data(l,m,i)*p(m,i)
        ww=ww-data(l,j,i)
      f(k,l)=f(k,l)+p(j,i)*data(k,j,i)*ww
  560 continue
  550 continue
  540 continue
c
  500 continue
c
      do 20 i=1,nn
      do 20 j=1,nn
   20 gj(i,j)=f(i,j)
c
      call inv(n2,nn,gj,nb)
c
      do 24 i=1,nn
      dx(i)=0.0d0
        do 25 j=1,nn
        dx(i)=dx(i)+gj(i,j)*(-fu(j))
        ff(i,j)=gj(i,j)
   25   continue
      x(i)=x(i)+dx(i)
      theta(i)=x(i)
   24 continue
c
       h=0.0
      do 40 i=1,nn
      if(x(i).eq.0.0)  x(i)=0.001
   40 h=h+(dx(i)/x(i))**2
      if(h.lt.eps)  go to 1000
       it=it+1
c
      write(6,700) it
  700 format(1h0,10x,'it=',i3)
      write(6,710)(x(j),j=1,nn)
  710 format(1h ,10x,'x',10d11.4)
      write(6,720)(fu(j),j=1,nn)
  720 format(1h ,9x,'fu',10d11.4)
      write(6,730)(dx(j),j=1,nn)
  730 format(1h ,9x,'dx',10d11.4)
c
      if(it.le.50)   go to 1
 1000 write(6,200) it
  200 format(//1h ,20x,'***** estimated parameter *****',20x,
     /      'num. of iterations =',i5)
c
      call tpara(theta,ff,ns,nn,mode,n1,n2,modeal,iidf)
c
c      calculation of likely-hood & chi-square
c
       al=0.0
      do 50 n=1,ns
      do 50 i=1,mode
      if(modeal(i,n).eq.0)  go to 50
      al=al+g(i,n)*alog(p(i,n))
   50 continue
      chisq=-2.0*(al0-al)
      idf=nn
      write(6,201) chisq,idf
  201 format(///1h0,20x,'chi-square =',f10.4,10x,'d.f. =',i5)
      write(6,202) al0,al
  202 format(//1h0,20x,'l*(0) =',f10.4,15x,'l*(*) =',f10.4)
      roh=1.0-al/al0
      fdn=iidf
      fnn=nn
      rohbar=1.0-(al/fdn/(al0/(fdn+fnn)))
      write(6,203) roh,rohbar
  203 format(//1h0,20x,'roh =',f10.4,17x,'rohbar =',f10.4)
c
c
      write(6,300)
  300 format(//1h ,10x,'***** information matrix *****')
c
      call print(f,n2,nn)
c
      do 580 i=1,nn
      do 580 j=1,nn
  580 ff(i,j)=-ff(i,j)
      write(6,301)
  301 format(//1h ,10x,'***** dispertion matrix *****')
c
      call print(ff,n2,nn)
c
      do 60 j=1,nn
      do 60 i=1,nn
   60 f(i,j)=ff(i,j)/sqrt(ff(i,i)*ff(j,j))
      write(6,302)
  302 format(//1h ,10x,'***** parameter correlation matrix *****')
c
      call print(f,n2,nn)
c
      return
      end
c
c
c
      subroutine meansd(data,ns,nn,mode,n1,n2,ave,sd,modeal,gs)
c
c        calculation & print of data mean & sd
c
      dimension data(n2,n1,1),ave(n2,1),gs(1),sd(n2,1)
      integer*2 modeal(n1,1)
c
      do 10 i=1,mode
       gs(i)=0.0
      do 10 j=1,nn
      ave(j,i)=0.0
   10 sd(j,i)=0.0
c
      do 20 n=1,ns
      do 20 m=1,mode
      if(modeal(m,n).eq.0)   go to 20
      gs(m)=gs(m)+1.0
c
      do 25 i=1,nn
      ave(i,m)=ave(i,m)+data(i,m,n)
   25 sd(i,m)=sd(i,m)+data(i,m,n)*data(i,m,n)
c
   20 continue
c
      do 30 m=1,mode
      do 30 i=1,nn
      ave(i,m)=ave(i,m)/gs(m)
      sd(i,m)=sd(i,m)/gs(m)-ave(i,m)*ave(i,m)
   30 sd(i,m)=sqrt(sd(i,m))
c
      write(6,200)(m,m=1,mode)
  200 format(//1h ,///,30x,'*****  mean & s.d of data  *****',///,1h0,
     *           5x,'no.',10x,'mode=',5i15)
c
      do 40 i=1,nn
      write(6,201)i,(ave(i,m),m=1,mode)
  201 format(1h0,5x,i3,5x,'mean',6x,5(3x,e12.5))
      write(6,202)  (sd(i,m),m=1,mode)
  202 format(1h ,13x,'s.d.',6x,5(3x,e12.5))
      write(6,203)  (gs(m),m=1,mode)
  203 format(1h ,13x,'num.',6x,5f15.0)
   40 continue
c
       write(*,*) nn
c
      return
      end
c
c
c
      subroutine change(adt,lgn,lsp,lse,msc,ig,isp,ise,mode,nn,n1,n2,
     *                  dt)
      dimension adt(1),lgn(n1,1),lsp(n1,1),lse(1),       isp(1),dt(n2,1)
c  gneric data
      if(ig.eq.0) go to 1
      do 10 i=1,mode
      do 10 j=1,ig
   10 dt(j,i)=adt(lgn(i,j))
    1 continue
      nn=ig
c  mode-specific data
      do 20 i=1,mode
      is=isp(i)
      if(is.eq.0) go to 20
      do 21 j=1,is
      nn=nn+1
      do 21 k=1,mode
      dt(nn,k)=adt(lsp(i,j))
      if(k.ne.i) dt(nn,k)=0
   21 continue
   20 continue
c  socio-economic data
      if(ise.eq.0) go to 2
      do 30 j=1,ise
      do 30 i=1,mode-1
      nn=nn+1
      do 31 k=1,mode
      dt(nn,k)=adt(lse(j))
      if(k.ne.i) dt(nn,k)=0
   31 continue
   30 continue
    2 continue
c  mode-specific-constant data
      if(msc.eq.0) return
      do 40 i=1,mode-1
      nn=nn+1
      do 41 j=1,mode
      dt(nn,j)=1
      if(j.ne.i) dt(nn,j)=0
   41 continue
   40 continue
      return
      end
c
c
c
      subroutine tpara (theta,ff,ns,nn,mode,n1,n2,modeal,iidf)
c
c        t-value & etc. calculate
c
      dimension theta(1),ff(n2,1),modeal(n1,1)
      real*8    ff
      integer*2 modeal
c
c        calculate    degree of freedom
c
      iidf=0
      do 10 n=1,ns
      idf=0
      do 20 m=1,mode
   20  idf=idf+modeal(m,n)
      iidf=iidf+idf-1
   10 continue
      iidf=iidf-nn
c
c        calculate    t-value
c        print        estimated parameter,t-value & degree of freedom
c
      write(6,200)
  200 format (///1h0,5x,'no.',5x,'estimated parameter',10x,
     *         'standard error',10x,'t-value',10x,'d.f.')
c
      do 30 i=1,nn
      fff=abs(ff(i,i))
      fff=sqrt(fff)
      if(fff.eq.0.0)   fff=0.000001
      t=theta(i)/fff
c
      write(6,201) i,theta(i),fff,t,iidf
  201 format(1h0,5x,i3,5x,e19.7,7x,e17.7,7x,f10.4,5x,i8)
c
   30 continue
c
      return
      end
c
c
c
      subroutine print(a,n4,nn)
c
c          print matrix
c
      real*8 a(n4,1)
      m=nn/8+1
      do 10 i=1,m
      is=(i-1)*8+1
      ie=i*8
      if(is.gt.nn) go to 10
      if(ie.gt.nn) ie=nn
      write(6,200)(k,k=is,ie)
  200 format(1h0   ,8i15)
      do 20 j=1,nn
   20 write(6,201) j,(a(k,j),k=is,ie)
  201 format(1h ,i3,2x,8(d12.5,3x))
   10 continue
      return
       end
c
c
c
      subroutine maxprb(p,g,ns,mode,n1,pnum,ttj,pshr,pcor,sind)
c
c      calculate prediction success by maximum probability
c      pnum(i,j) ; the sum of the case where p(i,j) is maximum
c                  where actual alt.(i) ,pred.alt. (j)
c
      dimension p(n1,1),g(n1,1),pnum(n1+4,1),ttj(1),pshr(1),pcor(1),
     &          sind(1)
      integer*2 g
      mo1=mode+1
      mo2=mode+2
      do 10 j=1,mo2
      do 10 i=1,mode
      pnum(i,j)=0.0
   10 continue
c
      do 20 n=1,ns
      pmax=0.0
      do 30 j=1,mode
      if(g(j,n).eq.1) ia=j
      if(p(j,n).lt.pmax) go to 30
      pmax=p(j,n)
      jp=j
   30 continue
      pnum(ia,jp)=pnum(ia,jp)+1.0
   20 continue
      write(6,600)
  600 format(//1h ,/10x,'*** prediction success table ***'/
     &       1h0,15x,'( by maximum probability )')
c
      call print2(pnum,mode,n1)
c
      nq=0
      do 40 j=1,mode
   40 nq=nq+pnum(j,j)
      t=float(nq)/float(ns)*100.0
      write(6,202) t,nq,ns
  202 format(///1h0,10x,'Hit-ratio =',f10.5,'   =',i5,' / ',i5)
      return
      end
c
c
c
      subroutine print2(pnum,mode,n1)
c
c      calculate column & row total,prediction & observed share
c      print (alt.)x(alt.) matrix , prediction success table
c
      dimension pnum(n1+4,1)
c
      do 5 i=1,mode
      pnum(mode+1,i)=0.0
    5 pnum(mode+2,i)=0.0
c
      ts=0.0
      do 10 i=1,mode
      do 10 j=1,mode
      pnum(mode+1,i)=pnum(mode+1,i)+pnum(j,i)
      pnum(mode+2,i)=pnum(mode+2,i)+pnum(i,j)
   10 ts=ts+pnum(i,j)
      do 20 i=1,mode
      pnum(mode+3,i)=pnum(mode+1,i)/ts*100.
   20 pnum(mode+4,i)=pnum(mode+2,i)/ts*100.
c
      write(6,100)
  100 format(//1h ,'(actual,predict) MATRIX')
      do 30 i=1,mode
   30 write(6,110) (pnum(i,j),j=1,mode)
  110 format(1h ,3x,12f6.1)
      write(6,115)
  115 format(/1h ,'volume')
      write(6,120) (pnum(mode+1,i),i=1,mode),ts
  120 format(1h ,'predict  ',12f6.1)
      write(6,130) (pnum(mode+2,i),i=1,mode),ts
  130 format(1h ,'actual   ',12f6.1)
      write(6,135)
  135 format(/1h ,'share (%)')
      write(6,120) (pnum(mode+3,i),i=1,mode)
      write(6,130) (pnum(mode+4,i),i=1,mode)
c
      return
      end
c
c
c
      subroutine errchk(n1,n2,nss,mode,nn,ns,modeal,g,gs)
      dimension modeal(n1,nss),g(n1,nss),gs(n1)
      integer*2 modeal,g
c
      do 5 m=1,mode
    5 gs(m)=0.
c
      if(nn.gt.n2) write(6,101)
  101 format(1h ,' Num. of Parameters is greater than MEMORY LIMIT.'/
     *            '   n2 must be greater than nn.')
      if(ns.gt.nss) write(6,102)
  102 format(1h ,' Num. of Samples is greater than MEMORY LIMIT.'/
     *            '   nss must be greater than ns.')
      do 10 n=1,ns
c
      mav=0
      do 20 m=1,mode
      if(modeal(m,n).eq.0 .and. g(m,n).eq.1) then
        write(6,103) n,m
  103   format(1h ,'NS:',i4,' choices  Mode',i3,
     *             ' but the mode is not available')
      end if
      mav=mav+modeal(m,n)
      if(g(m,n).eq.1) gs(m)=gs(m)+1.
   20 continue
      if(mav.le.1) write(6,104) n
  104 format(1h ,'NS:',i4,' has only 0 or 1 available mode'/
     *           ' The sample must be excluded')
c
   10 continue
c
      do 30 m=1,mode
   30 if(gs(m).le.0.) write(6,105) m
  105 format(1h ,' Nobody choiced Mode ',i3)
c
      return
      end
c
c
c
      subroutine inv(n1,nn,gj,nb)
      dimension gj(n1,1),nb(n1,1)
      real*8 gj,amx,a
c
      nn2=nn*2
      do 10 i=1,nn
      nb(i,1)=i
      nb(i,2)=i
      do 11 j=nn+1,nn2
   11 gj(i,j)=0.0d0
   10 continue
c
      do 20 i=1,nn
c
      amx=0.0d0
      do 21 j=i,nn
        do 22 k=1,nn
        a=abs(gj(j,k))
        if(a.gt.amx) then
          amx=a
          m1=j
          m2=k
        end if
   22   continue
   21 continue
c
      if(m1.ne.i) then
      k=nb(m1,1)
      nb(m1,1)=nb(i,1)
      nb(i,1)=k
        do 23 j=1,nn2
        a=gj(m1,j)
        gj(m1,j)=gj(i,j)
        gj(i,j)=a
   23   continue
      end if
c
      if(m2.ne.i) then
      k=nb(m2,2)
      nb(m2,2)=nb(i,2)
      nb(i,2)=k
      do 24 j=1,nn
        a=gj(j,m2)
        gj(j,m2)=gj(j,i)
        gj(j,i)=a
   24   continue
      end if
c
      gj(i,i+nn)=1.0d0
      a=1.0d0/gj(i,i)
      do 25 j=i,i+nn
   25 gj(i,j)=gj(i,j)*a
      do 26 j=1,nn
      if(j.ne.i) then
        a=gj(j,i)
        do 27 k=i,i+nn
   27   gj(j,k)=gj(j,k)-a*gj(i,k)
      end if
   26 continue
c
   20 continue
c
      do 30 i=1,nn
      do 31 j=1,nn
      m1=nb(i,2)
      m2=nb(j,1)
      gj(m1,m2)=gj(i,j+nn)
   31 continue
   30 continue
c
c
      return
      end
